//====================================================================================================
// Main.cpp
//====================================================================================================

#include "StdAfx.h"
#include "App.h"  //   
//#include "Common.h"  //      


//====================================================================================================
// wWinMain() -  
//====================================================================================================
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpstrCmdLine, int nCmdShow) {
  //     (  )
  APPMEMVARS struAppVars = {0};
  
  //   
  struAppVars.hInstance = hInstance;

#if IS_DLL
  //     
  CAppInterface *pCIApp = GetAppInterface();
#else 
  //     
  CAppInterface *pCIApp = new CApp;
#endif

  //          
  pCIApp->InitAppVars(struAppVars);

  //    
  if (!pCIApp->RegisterMainWindow()) return 0;
  
  //    
  if (!pCIApp->CreateMainWindow()) return 0;

  //    
  int nRes = pCIApp->MainMessageLoop();

  return nRes;
} // wWinMain()

//====================================================================================================
//====================================================================================================
