//====================================================================================================
// Common.h -  
//====================================================================================================

#pragma once

#include "StdAfx.h"
//#include "Plugin.h"
//#include "DllLoader.h"
#include "Ini.h"

//#define DLL_API __declspec(dllexport)
//
//
////====================================================================================================
//// Typedefs
////====================================================================================================
////typedef wstring WSAFILEVARS[];
//typedef vector<wstring> WSVECTOR;

//class CDllLoaderInterface;

////====================================================================================================
//// class CDllLoaderInterface -    
////====================================================================================================
//class CDllLoaderInterface {
//  //----------------------------------------------------------------------------------------------------
//  //  
//  //----------------------------------------------------------------------------------------------------
//  public:
//    //   dll   wsDllPathMask
//	  virtual void LoadAllDll(LPCWSTR pwsDllPathMask) = 0;
//
//    //     dll
//	  virtual void UnloadAllDll();
//
//    //         
//    virtual void GetAllPluginInterfaces(PIPLUGINVEC *pvPIPlugin) = 0;
//
//  //----------------------------------------------------------------------------------------------------
//  //  
//  //----------------------------------------------------------------------------------------------------
//  private:
//    //  dll    
//	  virtual void LoadDll(LPCWSTR pwsDllPath) = 0;
//
//    //  dll    
//	  virtual void UnloadDll(HMODULE hDll, wstring &wsDllPath) = 0;
//
//    //  , : CPluginInterface
//    virtual PIPLUGIN GetPluginInterface(HMODULE hDll, wstring &wsDllPath) = 0;
//};  // class CDllLoaderInterface

//====================================================================================================
// class CCommonInterface -         
//====================================================================================================
class CCommonInterface : public CIniInterface {  // CDllLoaderInterface,
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
	public:
    //      
    virtual void MakeFolders(LPCWSTR wsFilePath) = 0;

    //   a*b/c    ,     
    virtual long CalcProportion(long a, long b, long c) = 0;
};  // class CCommonInterface

//====================================================================================================
// Typedef -    CCommonInterface    , , CCommon
//====================================================================================================
typedef CCommonInterface *PICOMMON;

//====================================================================================================
// class CCommon -         
//====================================================================================================
class CCommon : public CCommonInterface {
  ////----------------------------------------------------------------------------------------------------
  //// class CDllLoaderInterface
  ////----------------------------------------------------------------------------------------------------
  //public:
  //  //   dll   wsDllPathMask
  //	virtual void LoadAllDll(LPCWSTR pwsDllPathMask) override;
  //
  //  //     dll
  //	virtual void UnloadAllDll();
  //
  //  //         
  //  virtual void GetAllPluginInterfaces(vector<CPluginInterface *> *pvPIPlugin) override;  // PIPLUGINVEC
  //
  //private:
  //  //  dll    
  //	virtual void LoadDll(LPCWSTR pwsDllPath) override;
  //
  //  //  dll    
  //	virtual void UnloadDll(HMODULE hDll, wstring &wsDllPath) override;
  //
  //  //  , : CPluginInterface
  //  virtual PIPLUGIN GetPluginInterface(HMODULE hDll, wstring &wsDllPath) override;

  //----------------------------------------------------------------------------------------------------
  // class CIniInterface
  //----------------------------------------------------------------------------------------------------
	public:
    //     ini-
    virtual void ReadIniFile(LPCWSTR pwsIniFile, WSAFILEVARS wsaFileVars, int nFileVarsCount) override;

    //     ini-
    virtual void WriteIniFile(LPCWSTR pwsIniFile, WSAFILEVARS wsaComments, WSAFILEVARS wsaFileVars, int nFileVarsCount) override;

  //----------------------------------------------------------------------------------------------------
  //    CCommon
  //----------------------------------------------------------------------------------------------------
	public:
    //      
    virtual void MakeFolders(LPCWSTR wsFilePath) override;

    //   a*b/c    ,     
    virtual long CalcProportion(long a, long b, long c) override;

  ////----------------------------------------------------------------------------------------------------
  ////  CDllLoaderInterface
  ////----------------------------------------------------------------------------------------------------
  //private:
  //  // 
  //  static WSVECTOR m_WSPlugins;  //     
  //  static HMODULEVEC m_HModules;  //    
  //  static PIPLUGINVEC m_PIPlugins;  //      

  ////----------------------------------------------------------------------------------------------------
  ////  CIniInterface
  ////----------------------------------------------------------------------------------------------------
  //private:

  ////----------------------------------------------------------------------------------------------------
  ////  
  ////----------------------------------------------------------------------------------------------------
  //private:
};  // class CCommon

#if IS_DLL
  //====================================================================================================
  // GetCommonInterface() -   ,    cpp-
  //====================================================================================================
  extern "C" DLL_API CCommonInterface *GetCommonInterface();
#endif

//====================================================================================================
//====================================================================================================
