//====================================================================================================
// Plugin.h -        
//====================================================================================================

#pragma once

#include "Common.h"  //      

//====================================================================================================
//     
//====================================================================================================
typedef struct {
  //   
  ofstream *pofsAppLog;  //  -
  //LPCWSTR pwsAppIniFile;  //  ini-
  //wstring wsAppWinClass;  //    
  //wstring wsAppMenuName;  //     
  //wstring wsAppAccelTable;  //      
  int nWorkWidth;  //     ( )
  int nWorkHeight;  //     ( )
  HINSTANCE hInstance;  //  
	HWND hAppWnd;  //   
	HWND hMDIClient;  //  MDI   
	HMENU hAppMenu;  //   

  //   
  int nAppX;  //      ( )
  int nAppY;  //      ( )
  int nAppWidth;  //    ( )
  int nAppHeight;  //    ( )
} APPMEMVARS;

class CCommonInterface;

//====================================================================================================
// class CPluginInterface -        
//====================================================================================================
class CPluginInterface {
  //----------------------------------------------------------------------------------------------------
  //  
  //----------------------------------------------------------------------------------------------------
	public:
    //   
    virtual void InitParams(APPMEMVARS &struAppVars, CCommonInterface *pIIni) = 0;

    //   MDI 
    virtual BOOL RegisterMDIChild() = 0;

    //   MDI 
    virtual BOOL CreateMDIChildWnd() = 0;

    //     
    virtual BOOL IsRegistration() = 0;

    //     
    virtual HWND GetHChildWnd() = 0;

    //     
    virtual wstring &GetMenuCommand() = 0;
};  // class CPluginInterface

//    CPluginInterface    , , CPlugWin
typedef CPluginInterface *PIPLUGIN;

//       
typedef vector<PIPLUGIN> PIPLUGINVEC;

//       
typedef vector<HMODULE> HMODULEVEC;

//====================================================================================================
//====================================================================================================
