//====================================================================================================
// StdAfx.h
//====================================================================================================
#pragma once

//     (1) /  (0) 
#define IS_DLL  1

#include <windows.h>
#include <winbase.h>
#include <commctrl.h>
#include <sstream>  // WOSS -      
#include <fstream>
#include <codecvt>
#include <vector>
#include <map>
#include <stdlib.h>
#include <math.h>
#include <wingdi.h>

#pragma comment(lib,"msimg32.lib")
using namespace std;

//====================================================================================================
// Global constants
//====================================================================================================
//       ( ,    
//  ),      
static const int SERVICES_BASE = WM_USER;  // (= 0x0400)     
static const int PLUGINS_BASE = WM_APP;  // (0x8000)      ()    

//====================================================================================================
// Defines
//====================================================================================================

//     wstring (  - stoi())
#define WOSS( x ) static_cast< wostringstream & >( ( wostringstream() << dec << x ) ).str()

#define DLL_API __declspec(dllexport)

#if defined _M_IX86
  #pragma comment(linker, "/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_IA64
  #pragma comment(linker, "/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
  #pragma comment(linker, "/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
  #pragma comment(linker, "/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif
//====================================================================================================
// Typedefs
//====================================================================================================

//typedef wstring WSAFILEVARS[];
typedef vector<wstring> WSVECTOR;

//====================================================================================================
//====================================================================================================
